/*******************************************************************************
*  GPSclock.c | forf[^K[̃eXg(GPSvF32MHzo[W)          *
*                                                                              *
*  FGPS̓tEǂݏoLCDɕ\sASDJ[hɂ͋L^ȂB    *
*        $GPRMC̃ZeX̂1bɎMpB                         *
*        ǂݏotÉAUTCȂ̂JST(GMT+9)ɕϊLCDɕ\sB*
*        UTCOjbWWԂ1970/1/1 00:00:00̌oߕb+TZɕϊ *
*        ̕ϊɂA"time.h"ԊǗ̕WCupolɂȂB*
*                                                                              *
* ============================================================================ *
*  VERSION DATE        BY                    CHANGE/COMMENT                    *
* ---------------------------------------------------------------------------- *
*  1.01    2017-02-03  ޒH[(ނ)  Create                            *
* ============================================================================ *
*  PIC 18F25K22 18F26K22                                                       *
*  MPLAB X(V2.15/V3.50)                                                        *
*  MPLAB(R) XC8 C Compiler Version 1.32/1.38/1.40                              *
*******************************************************************************/
#include <xc.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>                       // ԊǗ̕WCup
#include "skUARTlib.h"
#include "skI2Clib.h"
#include "skI2CLCDlib.h"

#define _XTAL_FREQ            32000000  // delaypɕKv(NbN32MHzw)
// 萔̒`
#define SENTENCES_BUFLEN      82        // GPS̃bZ[Wf[^obt@̌
#define TZ                     9        // {̃^C][iGMT+9j

//  vg^Cv̐錾
void Wait(unsigned int num) ;
char CksumCalc(char *dt) ;
void GPS_PSRF103Send(int msg,int rate) ;
void GPS_DisplayTime() ;
void GPS_StatusCheck(void) ;
int  GPS_GetMessageItem(char *dt1,char *dt2,int cnt) ;
time_t MakeTime(char Year,char Mon,char mDay,char Hour,char Min,char Sec) ;

// ʕϐ̐錾
char SentencesData[SENTENCES_BUFLEN] ;  // GPS̃ZeXf[^obt@
int  SentencesNum ;                     // GPS̃ZeX
int  GPS_Status ;                       // GPS̎M 0: 1:L
// \̂̐錾Ə
struct {                                // ZeX̏o͐
  int Msg ;                             // bZ[WID(PSRF103Msg)
  int Rate ;                            // 0:o͂Ȃ 1-255(b):o͊Ԋu
} MsgControlInfo[] = {
  {0,0} , // "$GPGGA"
  {2,0} , // "$GPGSA"
  {4,1} , // "$GPRMC"  o͕K{ł
  {1,0} , // "$GPGLL"
  {3,0} , // "$GPGSV"
  {5,0} , // "$GPVTG"
  {8,0} , // "$GPZDA"
} ;

// RtBM[V̐ݒ(̋Lqɖݒ̓ftHglł̓)
// ONbN͎gpȂ(PRICLKEN_OFF)
// NbNS{ł͓삳Ȃ(PLLCFG_OFF)Fۯgp(INTIO67)
#pragma config PRICLKEN=OFF,PLLCFG=OFF,FOSC=INTIO67    // CONFIG1H
// dd~펞Ď@\ON(BOREN_NOSLP)FĎd(2.85V)ɐݒ
// dON65.6ms۸тJn(PWRTEN_ON)
#pragma config BOREN=NOSLP,BORV=285,PWRTEN=ON          // CONFIG2L
// ޯϰ(WDTEN_OFF)
#pragma config WDTEN=OFF                               // CONFIG2H
// OؾĐM͎gp޼ٓ(RE3)݂Ƃ(MCLRE_INTMCLR)
// IV[^肷̂҂ăVXeNbN(HFOFST_OFF)
#pragma config MCLRE=INTMCLR,HFOFST=OFF                // CONFIG3H
// dvO~O@\gpȂ(LVP_OFF)
#pragma config LVP=OFF                                 // CONFIG4L

// 荞݂̏
void interrupt InterFunction( void )
{
     // hQb֘Å荞(LCDŗp)
     InterI2C() ;
     // tr`qs֘Å荞(GPSŗp)
     InterUART() ;
}
// C̏
void main()
{
     int  i , ans ;
     char dt , x ;

     PLLEN  = 1;              // NbN4x{ŗp
     OSCCON = 0b01100000;     // NbNƂ(8MHzx4=32MHz)
     INTCON2bits.RBPU = 0 ;   // vAbvs
     WPUB   = 0b00000110 ;    // RB1/RB2vAbv
     ANSELA = 0b00000000 ;    // AN0-4AiO͎gpȂAfW^I/OɊ
     ANSELB = 0b00000000 ;    // AN8-13AiO͎gpȂAfW^I/OɊ
     ANSELC = 0b00000000 ;    // AN14-19AiO͎gpȂAfW^I/OɊ
     TRISA  = 0b00000000 ;    // RA0-RA7Sďo͂ɐݒ
     TRISB  = 0b00000110 ;    // RB1(SCL)RB2(SDA)͓́A͑SďóA1œ 0ŏo
     TRISC  = 0b10000000 ;    // RC7(RX)͓́A͑SďóA1œ 0ŏo
     PORTA  = 0b00000000 ;    // o̓s̏(SLOWɂ)
     PORTB  = 0b00000000 ;    // o̓s̏(SLOWɂ)
     PORTC  = 0b00000000 ;    // o̓s̏(SLOWɂ)

     // I2CʐM̃}X^[[hŏsAʐMx400KHz
     InitI2C_Master(1) ;
     // I2Cڑ^LCDW[̏
     // ICON OFF,RgXg(0-63),VDD=3.3VŎg,LCD8
     LCD_Init(LCD_NOT_ICON,32,LCD_VDD3V,8) ;
     LCD_Puts("StartGPS") ;
     // USARTʐM̏s(4800bps)(9600bps416->207ɕύX)
     InitUART(0,0,416) ;
     // ϐނ̏s
     SentencesNum = -1 ;
     GPS_Status   = 0 ;
     // GPSփZeX̏o͐𑗐M("$GPRMC"̂1bɏo)
     for (x=0 ; x<7 ; x++) {
          GPS_PSRF103Send(MsgControlInfo[x].Msg,MsgControlInfo[x].Rate) ;
     }

     while(1) {
          // ZeXf[^LȂ珈s
          ans = UART_Available() ;
          if (ans != 0) {
               // 1oCgǂݏo
               dt = UART_Read() ;
               // ZeX̊Jn
               if (dt == '$') SentencesNum = 0 ;
               if (SentencesNum >= 0) {
                    // ZeXobt@ɗ߂
                    SentencesData[SentencesNum] = dt ;
                    SentencesNum++ ;
                    // ZeX̍Ō(LF=0x0AŔf)
                    if (dt == 0x0a || SentencesNum >= SENTENCES_BUFLEN) {
                         // ZeX̃Xe[^X"L"ɂȂ܂ő҂
                         if (GPS_Status == 0) GPS_StatusCheck() ;
                         else {
                              // LɂȂLCDɎ\
                              GPS_DisplayTime() ;
                         }
                         SentencesNum = -1 ;
                    }
               }
          }
     }
}
/*******************************************************************************
*  GPS_PSRF103Send(msg,rate)                                                   *
*    bZ[WID103vgR쐬GPSɑM鏈                      *
*                                                                              *
*    msg  : 䂷郁bZ[W(ZeX)̎ނw肵܂                   *
*           0:GGA 1:GGL 2:GSA 3:GSV 4:RMC 5:VTG 6:MSS 8:ZDA                    *
*    rate : o͂郁bZ[W̊Ԋuw肵܂                               *
*           OFo͂Ȃ  P?QTT:o͂ԊubŐݒ                  *
*******************************************************************************/
void GPS_PSRF103Send(int msg,int rate)
{
    char c , buf[24] ;

    // M郁bZ[W̍쐬s
    memset(buf,0x00,sizeof(buf)) ;
    strcat(buf,"$PSRF103,") ;      // Message ID
    buf[9] = msg + 0x30 ;          // Msg
    strcat(buf,",0,") ;            // Mode (Rate̐ݒsĂw)
    itoa(&buf[13],rate,10) ;       // Rate
    strcat(buf,",1") ;             // CksumEnable (`FbNT͕t)
    c = CksumCalc(&buf[1]) ;       // `FbNŤvZs
    strcat(buf,"*") ;              // Checksum
    itoa(&buf[strlen(buf)],c,16) ;
    c = strlen(buf) ;
    buf[c]   = 0x0d ;              // CR
    buf[c+1] = 0x0a ;              // LF
    // bZ[W̑Ms
    UART_Send(buf,c+2) ;
}
// `FbNŤvZs
char CksumCalc(char *dt)
{
     char ans ;
     int i , len ;

     len = strlen(dt) ;
     ans = *dt ;
     for (i=1 ; i<len ; i++) {
          dt++ ;
          ans = ans ^ *dt ;
     }
     return ans ;
}
/*******************************************************************************
*  GPS_DisplayTime()                                                           *
*    tƎJSTɕϊ\鏈                                       *
*******************************************************************************/
void GPS_DisplayTime()
{
     time_t  jst ;
     struct tm *T ;
     char buf[26] ;
     int  i , j , ans , dt[6] ;

     memset(buf,0x20,sizeof(buf)) ;
     ans = GPS_GetMessageItem(&buf[1],(char *)"$GPRMC",1) ;  // o(UTC)
     ans = GPS_GetMessageItem(&buf[13],(char *)"$GPRMC",9) ; // to(UTC)
     if (ans == 1) {
          buf[23] = 0x00 ;
          // 𐔒lɕϊ
          j = 1 ;
          for (i=0 ; i<3 ; i++) {
               dt[i] = atoi(memcpy(&buf[21],&buf[j],2)) ;
               j = j + 2 ;
          }
          // t𐔒lɕϊ
          j = 13 ;
          for (i=3 ; i<6 ; i++) {
               dt[i] = atoi(memcpy(&buf[21],&buf[j],2)) ;
               j = j + 2 ;
          }
          // OjbWWԂ1970/1/1 00:00:00̌oߕb+TZɕϊ
          jst = MakeTime(dt[5],dt[4],dt[3],dt[0],dt[1],dt[2]) ;
          // oߕb+TZ̒ltm\̂ɕϊ
          T = gmtime(&jst) ;
          sprintf(buf,"%d/%02d/%02d\0",T->tm_year+1900,T->tm_mon+1,T->tm_mday) ;
          LCD_SetCursor(0,0) ;     // 1sڂɓt\
          LCD_Puts(&buf[2]) ;      // "yyyy/mm/dd"
          sprintf(buf,"%02d:%02d:%02d\0",T->tm_hour,T->tm_min,T->tm_sec) ;
          LCD_SetCursor(0,1) ;     // 2sڂɎ\
          LCD_Puts(buf) ;          // "hh:mm:ss"
     }
}
/*******************************************************************************
*  GPS_StatusCheck()                                                           *
*    GPS̃ZeXLׂ鏈                                         *
*    "$GPRMC"bZ[W2ڂ̕Ŕf܂B                           *
*******************************************************************************/
void GPS_StatusCheck()
{
     char buf[8] ;
     int  ans ;
     
     memset(buf,0x00,sizeof(buf)) ;
     ans = GPS_GetMessageItem(buf,(char *)"$GPRMC",2) ;
     if (ans == 1 && buf[0] == 'A') {
          // Xe[^X"L"
          LCD_SetCursor(0,1) ;
          LCD_Puts("used OK!") ;
          GPS_Status = 1 ;
     }
}
/*******************************************************************************
*  ans = GPS_GetMessageItem(*dt1,*dt2,cnt)                                     *
*    GPSMZeX̊eڂo                           *
*    MbZ[W *dt2 ƈv ans=1 Ńp[^o܂B *
*    w肵ʒu(cnt)̃p[^o *dt1 ɓeݒ肵܂B *
*                                                                              *
*    dt1 : oZeX(p[^)̕Ԃ                  *
*          oi[obt@0x00ŏĒuǂł*
*    dt2 : $<vendor:2><message;3>wAႦ"$GPRMC"ł                  *
*    cnt : op[^̈ʒuw肵܂                                *
*          $GPRMC,075453.000,A,*68cnt=2Ȃdt1="A"ƂȂk͕tȂB*
*    ans : w*dt2 ƈvans=1ŕsvȂans=0                       *
*******************************************************************************/
int GPS_GetMessageItem(char *dt1,char *dt2,int cnt)
{
     char *p ;
     int ans , i , j , c ;

     ans = 0 ;
     // MZeX́Aw̃bZ[Wƈvׂ
     if (strncmp((char *)SentencesData,dt2,6) == 0) {
          ans = 1 ;
          c   = 0 ;
          // ZeX̒JԂ
          for (i=0 ; i<SentencesNum ; i++) {
               if (SentencesData[i] == ',') c++ ; // ؂蕶𐔂
               if (c == cnt) {
                    // w肵ꏊ̋؂蕶Ȃ炻̃p[^Rs[
                    p = (char *)dt1 ;
                    for (j=i+1 ; j<SentencesNum ; j++) {
                         if (SentencesData[j]==',' || SentencesData[j]=='*') break ;
                         *p = SentencesData[j] ;
                         p++ ;
                    }
                    break ;
               }
          }
     }
     return ans ;
}
/*******************************************************************************
*  ans = MakeTime(Year,Mon,mDay,wDay,Hour,Min,Sec)                             *
*    w肵Ԃ1970/1/1 00:00:00̌oߕbɕϊ鏈               *
*    Ԃoߕb̓^C][ԂɕϊꂽlłB              *
*                                                                              *
*    Year : t̔N(70-99/00-38)w肷(̉QP^ 1970N-2038N)      *
*    Mon  : ť(1-12)w肷                                           *
*    mDay : t̓(1-31)w肷                                           *
*    Hour : ̎(0-23)w肷                                           *
*    Min  : ̕(0-59)w肷                                           *
*    Sec  : ̕b(0-61)w肷([bl)                               *
*    ans  : ͎w莞Ԃ܂ł̌oߕbԂA|PȂw莞Ԉُ         *
*******************************************************************************/
time_t MakeTime(char Year,char Mon,char mDay,char Hour,char Min,char Sec)
{
     time_t   ans ;
     struct tm t ;

     if (Year < 70) t.tm_year = Year + 100 ;
     else           t.tm_year = Year ;
     if ((Mon > 12) || (Mon < 1))   return (time_t)-1 ; // ̎wG[
     t.tm_mon = Mon - 1 ;
     if ((mDay > 31) || (mDay < 1)) return (time_t)-1 ; // ̎wG[
     t.tm_mday = mDay ;
     if (Hour > 23)                 return (time_t)-1 ; // ̎wG[
     t.tm_hour = Hour ;
     if (Min > 59)                  return (time_t)-1 ; // ̎wG[
     t.tm_min = Min ;
     if (Sec > 59)                  return (time_t)-1 ; // b̎wG[
     t.tm_sec = Sec ;

     ans = mktime(&t) ;
     if (ans == -1)                 return (time_t)-1 ; // N̎wG[
     return ans + (TZ * 60 * 60) ;                      // OjbWWԁ{TZɕϊĕԂ
}
